package cn.cecep.talroad.service.impl;

import cn.cecep.talroad.domain.MonDevHour;
import cn.cecep.talroad.mapper.MonDevHourMapper;
import cn.cecep.talroad.service.IMonDevHourService;
import cn.cecep.talroad.vo.MonDevGtVO;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;




/**
 * 设备数据(有组织)-其它时间 保存设备的小时以上的数据Service业务层处理
 *
 * @author szhpt
 * @date 2023-01-10*/
@Service
public class MonDevHourServiceImpl extends ServiceImpl<MonDevHourMapper,MonDevHour> implements IMonDevHourService
{
    @Autowired
    private MonDevHourMapper monDevHourMapper;

    /**
     * 查询设备数据(有组织)-其它时间 保存设备的小时以上的数据列表
     *
     * @param monDevHour 设备数据(有组织)-其它时间 保存设备的小时以上的数据
     * @return 设备数据(有组织)-其它时间 保存设备的小时以上的数据
     */
    @Override
    public List<MonDevHour> selectMonDevHourList(MonDevHour monDevHour)
    {
        return monDevHourMapper.selectMonDevHourList(monDevHour);
    }

    @Override
    public List<MonDevGtVO> getDataPage(String factoryId, List<String> deviceIds, String startTime, String endTime, String orderField, String orderType, Page page) {
        QueryWrapper<MonDevGtVO> queryWrapper = new QueryWrapper<MonDevGtVO>()
                .eq("r.factory_id", factoryId)
                .in("r.device_id", deviceIds)
                .ge("r.data_time", startTime)
                .le("r.data_time", endTime)
                .orderBy(StringUtils.isNotEmpty(orderField), "asc".equals(orderType), orderField, "r.data_id");
        return baseMapper.getDataPage2(page, queryWrapper);
    }

}
